commit 667339efd8ee10079aac9684c5d1c9c9b28d9da6
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Thu Jul 22 15:37:24 2021

    libstdc++: Use std::addressof in ranges::uninitialized_xxx [PR101571]
    
    Make the ranges::uninitialized_xxx algorithms use std::addressof to
    protect against iterator types that overload operator&.
    
    Signed-off-by: Jonathan Wakely <jwakely@redhat.com>
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/101571
            * include/bits/ranges_uninitialized.h (_DestroyGuard): Change
            constructor parameter to reference and use addressof.
            * testsuite/util/testsuite_iterators.h: Define deleted operator&
            overloads for test iterators.
    
    (cherry picked from commit aca7a0253d6e3116f846ad530b19d89644a64267)

diff --git a/libstdc++-v3/include/bits/ranges_uninitialized.h b/libstdc++-v3/include/bits/ranges_uninitialized.h
index 0a46fba9b8e..40664ea7a04 100644
--- a/libstdc++-v3/include/bits/ranges_uninitialized.h
+++ b/libstdc++-v3/include/bits/ranges_uninitialized.h
@@ -106,8 +106,8 @@ namespace ranges
 
       public:
 	explicit
-	_DestroyGuard(const _Iter* __iter)
-	  : _M_first(*__iter), _M_cur(__iter)
+	_DestroyGuard(const _Iter& __iter)
+	  : _M_first(__iter), _M_cur(std::__addressof(__iter))
 	{ }
 
 	void
@@ -127,7 +127,7 @@ namespace ranges
       struct _DestroyGuard<_Iter>
       {
 	explicit
-	_DestroyGuard(const _Iter*)
+	_DestroyGuard(const _Iter&)
 	{ }
 
 	void
@@ -149,7 +149,7 @@ namespace ranges
 	  return ranges::next(__first, __last);
 	else
 	  {
-	    auto __guard = __detail::_DestroyGuard(&__first);
+	    auto __guard = __detail::_DestroyGuard(__first);
 	    for (; __first != __last; ++__first)
 	      ::new (__detail::__voidify(*__first)) _ValueType;
 	    __guard.release();
@@ -181,7 +181,7 @@ namespace ranges
 	  return ranges::next(__first, __n);
 	else
 	  {
-	    auto __guard = __detail::_DestroyGuard(&__first);
+	    auto __guard = __detail::_DestroyGuard(__first);
 	    for (; __n > 0; ++__first, (void) --__n)
 	      ::new (__detail::__voidify(*__first)) _ValueType;
 	    __guard.release();
@@ -207,7 +207,7 @@ namespace ranges
 	  return ranges::fill(__first, __last, _ValueType());
 	else
 	  {
-	    auto __guard = __detail::_DestroyGuard(&__first);
+	    auto __guard = __detail::_DestroyGuard(__first);
 	    for (; __first != __last; ++__first)
 	      ::new (__detail::__voidify(*__first)) _ValueType();
 	    __guard.release();
@@ -240,7 +240,7 @@ namespace ranges
 	  return ranges::fill_n(__first, __n, _ValueType());
 	else
 	  {
-	    auto __guard = __detail::_DestroyGuard(&__first);
+	    auto __guard = __detail::_DestroyGuard(__first);
 	    for (; __n > 0; ++__first, (void) --__n)
 	      ::new (__detail::__voidify(*__first)) _ValueType();
 	    __guard.release();
@@ -279,7 +279,7 @@ namespace ranges
 	  }
 	else
 	  {
-	    auto __guard = __detail::_DestroyGuard(&__ofirst);
+	    auto __guard = __detail::_DestroyGuard(__ofirst);
 	    for (; __ifirst != __ilast && __ofirst != __olast;
 		 ++__ofirst, (void)++__ifirst)
 	      ::new (__detail::__voidify(*__ofirst)) _OutType(*__ifirst);
@@ -326,7 +326,7 @@ namespace ranges
 	  }
 	else
 	  {
-	    auto __guard = __detail::_DestroyGuard(&__ofirst);
+	    auto __guard = __detail::_DestroyGuard(__ofirst);
 	    for (; __n > 0 && __ofirst != __olast;
 		 ++__ofirst, (void)++__ifirst, (void)--__n)
 	      ::new (__detail::__voidify(*__ofirst)) _OutType(*__ifirst);
@@ -368,7 +368,7 @@ namespace ranges
 	  }
 	else
 	  {
-	    auto __guard = __detail::_DestroyGuard(&__ofirst);
+	    auto __guard = __detail::_DestroyGuard(__ofirst);
 	    for (; __ifirst != __ilast && __ofirst != __olast;
 		 ++__ofirst, (void)++__ifirst)
 	      ::new (__detail::__voidify(*__ofirst))
@@ -419,7 +419,7 @@ namespace ranges
 	  }
 	else
 	  {
-	    auto __guard = __detail::_DestroyGuard(&__ofirst);
+	    auto __guard = __detail::_DestroyGuard(__ofirst);
 	    for (; __n > 0 && __ofirst != __olast;
 		 ++__ofirst, (void)++__ifirst, (void)--__n)
 	      ::new (__detail::__voidify(*__ofirst))
@@ -446,7 +446,7 @@ namespace ranges
 	  return ranges::fill(__first, __last, __x);
 	else
 	  {
-	    auto __guard = __detail::_DestroyGuard(&__first);
+	    auto __guard = __detail::_DestroyGuard(__first);
 	    for (; __first != __last; ++__first)
 	      ::new (__detail::__voidify(*__first)) _ValueType(__x);
 	    __guard.release();
@@ -479,7 +479,7 @@ namespace ranges
 	  return ranges::fill_n(__first, __n, __x);
 	else
 	  {
-	    auto __guard = __detail::_DestroyGuard(&__first);
+	    auto __guard = __detail::_DestroyGuard(__first);
 	    for (; __n > 0; ++__first, (void)--__n)
 	      ::new (__detail::__voidify(*__first)) _ValueType(__x);
 	    __guard.release();
diff --git a/libstdc++-v3/testsuite/util/testsuite_iterators.h b/libstdc++-v3/testsuite/util/testsuite_iterators.h
index 4e668d648f2..c5a65101fff 100644
--- a/libstdc++-v3/testsuite/util/testsuite_iterators.h
+++ b/libstdc++-v3/testsuite/util/testsuite_iterators.h
@@ -175,10 +175,14 @@ namespace __gnu_test
 #if __cplusplus >= 201103L
     template<typename U>
       void operator,(const U&) const = delete;
+
+    void operator&() const = delete;
 #else
   private:
     template<typename U>
       void operator,(const U&) const;
+
+    void operator&() const;
 #endif
   };
 
@@ -288,10 +292,14 @@ namespace __gnu_test
 #if __cplusplus >= 201103L
     template<typename U>
       void operator,(const U&) const = delete;
+
+    void operator&() const = delete;
 #else
   private:
     template<typename U>
       void operator,(const U&) const;
+
+    void operator&() const;
 #endif
   };
 

